package me.yeojoy.simplechat;

import me.yeojoy.simplechat.R;

import me.yeojoy.simplechat.adapter.ChatBaseAdapter;
import me.yeojoy.simplechat.data.ChattingData;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.ListView;

import java.util.ArrayList;
import java.util.List;

public class ChatActivity extends Activity {

    private static final String TEMP = "..";
    
    private EditText mEtInput;
    
    private ChatBaseAdapter mChatBaseAdapter;
    
    private List<ChattingData> mListChattingData;
    
    private ListView mLvChatting;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.chat);
        
        mLvChatting = (ListView) findViewById(R.id.lv_chat);
        
        mEtInput = (EditText) findViewById(R.id.et_input);
        mListChattingData = new ArrayList<ChattingData>();
        
        mChatBaseAdapter = new ChatBaseAdapter(this, mListChattingData); 
        mLvChatting.setAdapter(mChatBaseAdapter);
        
    }

    @Override
    protected void onResume() {
        super.onResume();
        
    }
    
    @Override
    protected void onPause() {
        super.onPause();
        
    }
    
    @Override
    protected void onDestroy() {
        // 여기
        super.onDestroy();
    }
    
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.btn_send:
                sendChattingMessage(true);
                mEtInput.setText("");
                break;
        }
    }

    private void sendChattingMessage(boolean isMine) {
        ChattingData chatting = new ChattingData();
        String message = mEtInput.getText().toString();
        
        if (!message.startsWith(TEMP)) {
            chatting.setComment(message);
            chatting.setImageUrl(null);
            chatting.setMine(true);
            chatting.setName(null);
            
        } else {
            message = message.substring(TEMP.length());
            chatting.setComment(message);
            chatting.setImageUrl(null);
            chatting.setMine(false);
            chatting.setName(null);
            
        }
        
        // List에 넣어주고 adapter에 notify 해주고
        // 보내기 궈궈씽
        mListChattingData.add(chatting);
        mChatBaseAdapter.notifyDataSetChanged();
        mLvChatting.invalidate();
        
        scrollMyListViewToBottom();
        
    }
    
    private void scrollMyListViewToBottom() {
        mLvChatting.setSelection(mChatBaseAdapter.getCount() - 1);
    }
    
}
