package me.yeojoy.simplechat;

import me.yeojoy.simplechat.R;

import me.yeojoy.simplechat.adapter.ChatBaseAdapter;
import me.yeojoy.simplechat.data.ChattingData;

import android.app.Activity;
import android.app.LoaderManager;
import android.content.Context;
import android.content.Loader;
import android.os.Bundle;
import android.support.v4.content.AsyncTaskLoader;
import android.view.View;
import android.widget.EditText;
import android.widget.ListView;

import java.util.ArrayList;
import java.util.List;

/**
 * AsyncTaskLoader를 사용해서 구현
 * @author yeojoy
 *
 */

public class ChatActivity2 extends Activity implements LoaderManager.LoaderCallbacks<List<ChattingData>> {

    private static final String TEMP = "..";
    
    private EditText mEtInput;
    
    private ChatBaseAdapter mChatBaseAdapter;
    
    private List<ChattingData> mListChattingData;
    
    private ListView mLvChatting;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.chat);
        
        mLvChatting = (ListView) findViewById(R.id.lv_chat);
        
        mEtInput = (EditText) findViewById(R.id.et_input);
        
        mListChattingData = new ArrayList<ChattingData>();
        
        mChatBaseAdapter = new ChatBaseAdapter(this, mListChattingData); 
        mLvChatting.setAdapter(mChatBaseAdapter);
    }

    @Override
    protected void onResume() {
        super.onResume();
        
    }
    
    @Override
    protected void onPause() {
        super.onPause();
        
    }
    
    @Override
    protected void onDestroy() {
        // 여기
        super.onDestroy();
    }
    
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.btn_send:
                sendChattingMessage();
                mEtInput.setText("");
                break;
        }
    }

    private void sendChattingMessage() {
        ChattingData chatting = new ChattingData();
        String message = mEtInput.getText().toString();
        
//        if (isMine) {
        if (!message.startsWith(TEMP)) {
            chatting.setComment(message);
            chatting.setImageUrl(null);
            chatting.setMine(true);
            chatting.setName("ME");
            chatting.setChatType(ChatBaseAdapter.CHAT_ROOM_TYPE_ME);
            
        } else {
            message = message.substring(TEMP.length());
            chatting.setComment(message);
            chatting.setImageUrl(null);
            chatting.setMine(true);
            chatting.setName("YOU");
            chatting.setChatType(ChatBaseAdapter.CHAT_ROOM_TYPE_YOU);
            
        }
        
        // List에 넣어주고 adapter에 notify 해주고
        // 보내기 궈궈씽
        mListChattingData.add(chatting);
//        mChatBaseAdapter.notifyDataSetChanged();
//        mLvChatting.invalidate();
        
//        scrollMyListViewToBottom();
        
    }
    
    private void scrollMyListViewToBottom() {
        mLvChatting.post(new Runnable() {
            @Override
            public void run() {
                // Select the last row so it will scroll into view...
                mLvChatting.setSelection(mChatBaseAdapter.getCount() - 1);
            }
        });
    }

    @Override
    public Loader<List<ChattingData>> onCreateLoader(int id, Bundle args) {
        // This is called when a new Loader needs to be created.  This
        // sample only has one Loader with no arguments, so it is simple.
        
        return null;
    }

    @Override
    public void onLoadFinished(Loader<List<ChattingData>> loader, List<ChattingData> data) {
        mListChattingData.addAll(data);
        mChatBaseAdapter.notifyDataSetChanged();
        scrollMyListViewToBottom();
    }

    @Override
    public void onLoaderReset(Loader<List<ChattingData>> loader) {
        // Clear the data in the adapter.
        int N = mListChattingData.size();
        for (int i = 0; i < N; i++) {
            mListChattingData.remove(i);
        }
//        mChatBaseAdapter.
    }
    
    // AsyncTaskLoader
    class ChatListLoader extends AsyncTaskLoader<List<ChattingData>> {

        public ChatListLoader(Context context) {
            super(context);
            
        }

        @Override
        public List<ChattingData> loadInBackground() {
            
            return null;
        }
        
    }
}
