package me.yeojoy.simplechat.adapter;

import me.yeojoy.simplechat.R;

import me.yeojoy.simplechat.db.ChatDatabase;

import android.app.Activity;
import android.content.Context;
import android.database.Cursor;
import android.support.v4.widget.CursorAdapter;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

public class ChatCursorAdapter extends CursorAdapter {

    public static final int CHAT_ROOM_TYPE_ME = 100001;
    public static final int CHAT_ROOM_TYPE_YOU = 100000;
    
    private int viewType;
    
    public ChatCursorAdapter(Context context, Cursor cursor, int flag) {
        super(context, cursor, flag);
    }
    
    @Override
    public View newView(Context context, Cursor cursor, ViewGroup viewGroup) {
        View view = null;
        viewType = cursor.getInt(cursor.getColumnIndex(ChatDatabase.IS_MINE)); 
        if (viewType == CHAT_ROOM_TYPE_ME) {
            view = ((Activity) context).getLayoutInflater().inflate(R.layout.my_side, null);
            if (view.getTag() == null) {
                MyViewHolder myHolder = new MyViewHolder();
                myHolder.mTvMyComments = (TextView) view.findViewById(R.id.tv_my_talk);
                myHolder.viewType = CHAT_ROOM_TYPE_ME;
                view.setTag(myHolder);
            }
        } else {
            view = ((Activity) context).getLayoutInflater().inflate(R.layout.your_side, null); 
            
            if (view.getTag() == null) {
                YourViewHolder yourHolder = new YourViewHolder(); 
                yourHolder.mTvYourName= (TextView) view.findViewById(R.id.tv_your_name);
                yourHolder.mTvYourComments = (TextView) view.findViewById(R.id.tv_your_talk);
                yourHolder.mIvYourImage = (ImageView) view.findViewById(R.id.iv_your_profile_image);
                yourHolder.viewType = CHAT_ROOM_TYPE_YOU;
                view.setTag(yourHolder);
            }
        }
        return view;
    }
    
    @Override
    public void bindView(View view, Context context, Cursor cursor) {
        
        if (view == null) return;
        Object viewHolder = view.getTag();
        
        if (viewHolder instanceof MyViewHolder) {
            MyViewHolder myHolder = (MyViewHolder) viewHolder;
            if (myHolder.viewType == CHAT_ROOM_TYPE_ME) {
                myHolder.mTvMyComments.setText(cursor.getString(cursor.getColumnIndex(ChatDatabase.USER_COMMENTS)));
            }
        } else if (viewHolder instanceof YourViewHolder) {
            YourViewHolder yourHolder = (YourViewHolder) viewHolder;
            if (yourHolder.viewType == CHAT_ROOM_TYPE_YOU) {
                yourHolder.mTvYourComments.setText(cursor.getString(cursor.getColumnIndex(ChatDatabase.USER_COMMENTS)));
                yourHolder.mTvYourName.setText(cursor.getString(cursor.getColumnIndex(ChatDatabase.USER_NAME)));
            }
        }
    }
    
    @Override
    public int getItemViewType(int position) {
        return super.getItemViewType(position);
    }
    
    
    
    @Override
    public void changeCursor(Cursor cursor) {
        super.changeCursor(cursor);
    }
    
    @Override
    protected void onContentChanged() {
        super.onContentChanged();
    }
    
    private class MyViewHolder {
        public TextView mTvMyComments;
        public int viewType;
    }
    
    private class YourViewHolder {
        public TextView mTvYourComments;
        public TextView mTvYourName;
        public ImageView mIvYourImage;
        public int viewType;
    }
    
}
